//   ,        CPU  
//    
#pragma offload_attribute(push, target(mic))

#include <stdio.h>
#include <omp.h>

void testThreadCount()
{
    int thread_count;

    #pragma omp parallel
    {
        #pragma omp single
            thread_count = omp_get_num_threads();
    }
    printf("Number of threads: %d\n", thread_count);
}

//     
#pragma offload_attribute(pop)

int main()
{
	//    
    printf("Intel CPU:\n");
    testThreadCount();

	//    
    int number_of_coprocessors = _Offload_number_of_devices();

    printf("Intel Xeon Phi:\n");
    printf("Number of coprocessors: %d\n", number_of_coprocessors);

    for (int i = 0; i < number_of_coprocessors; ++i)
    {
		//        i
        #pragma offload target(mic:i)
        {
            testThreadCount();
        }
    }

    return 0;
}
