#include <stdio.h>
#include <stdlib.h>

//   ,        CPU  
//    
#pragma offload_attribute(push, target(mic))

//     
float dot(float* a, float* b, int n)
{
    float res = 0;

    #pragma omp parallel for reduction(+: res)
    for (int i = 0; i < n; ++i)
    {
        res += a[i]*b[i];
    }

    return res;
}

//     
#pragma offload_attribute(pop)

int main()
{
    int n = 100;
    float* a = new float[n];
    float* b = new float[n];
    float res_cpu, res_mic;

    for (int i = 0; i < n; ++i)
    {
        a[i] = (float)rand()/RAND_MAX;
        b[i] = (float)rand()/RAND_MAX;
    }

	//     
    res_cpu = dot(a, b, n);
    
    printf("CPU dot: %f\n", res_cpu);

	//     .
	//  in    
	//  a  b  .    .
    #pragma offload target(mic) in(a[0:n], b[0:n])
    res_mic = dot(a, b, n);
    
    printf("MIC dot: %f\n", res_mic);

    delete[] a;
    delete[] b;

    return 0;
}
