#include <stdio.h>
#include <stdlib.h>

//     
float dot(float* a, float* b, int n)
{
    float res = 0;

    #pragma omp parallel for reduction(+: res)
    for (int i = 0; i < n; ++i)
    {
        res += a[i]*b[i];
    }

    return res;
}

int main()
{
    int n = 100;
    float* a = new float[n];
    float* b = new float[n];
    float res;

    for (int i = 0; i < n; ++i)
    {
        a[i] = (float)rand()/RAND_MAX;
        b[i] = (float)rand()/RAND_MAX;
    }

    res = dot(a, b, n);
    printf("Result: %f\n", res);

    delete[] a;
    delete[] b;

    return 0;
}
